local toc, data = ...
local AddonId = toc.identifier

WT.Unit.CreateVirtualProperty("CkaunameMini", { "name" },
	function(unit)
		if unit.name and unit.name:len() > 10 then
			CkaunameMini = unit.name:sub(1, 10) .. ""
			return CkaunameMini
		else
			return unit.name
		end
	end)
		
WT.Unit.CreateVirtualProperty("CkaunameMed", { "name" },
	function(unit)
		if unit.name and unit.name:len() > 40 then
			CkaunameMed = unit.name:sub(1, 40) .. ""
			return CkaunameMed
		else
			return unit.name
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkausubName", { "guild", "nameSecondary" },
    function(unit)
        return unit.guild or unit.nameSecondary or nil
    end)
	
WT.Unit.CreateVirtualProperty("rgStatus", { "offline", "afk", "health" },
	function(unit)
		if unit.offline then
			return "OFFLINE"
		elseif unit.afk then
			return "AFK"
		elseif unit.dead then
			return "DEAD"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaupvpFaction", { "race", "pvp" },
	function(unit)
		if not unit.pvp then
			return nil
		elseif unit.race == "bahmi" then
			return "defiant"
		elseif unit.race == "kelari" then
			return "defiant"
		elseif unit.race == "eth" then
			return "defiant"
		elseif unit.race == "highelf" then
			return "guardian"
		elseif unit.race == "mathosian" then
			return "guardian"
		elseif unit.race == "dwarf" then
			return "guardian"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauFaction", { "factionId", "pvp" },
	function(unit)
		if not unit.pvp then
			return nil
		elseif unit.factionId == "f0000000FEDCF3A7E" then
			return "dominion"
		elseif unit.factionId == "f000000117FB54BCE" then
			return "oathsworn"
		elseif unit.factionId == "f000000108924207A" then
			return "nightfall"
		else 
			return nil
		end
	end)

WT.Unit.CreateVirtualProperty("CkauhealthText", { "health", "afk", "dead", "offline" },
	function(unit)
		if unit.afk then
			return nil
		elseif unit.dead then
			return nil
		elseif unit.offline then
			return nil
		else
			return true
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauresourceText", { "resource", "castName", "afk", "dead", "offline" },
	function(unit)
		if unit.castName then
			return nil
		elseif unit.afk then
			return nil
		elseif unit.dead then
			return nil
		elseif unit.offline then
			return nil
		else
			return true
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauRaidCleanse", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return nil
		else
			return true
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaucleanseBar", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauunitTargeted", { "playerTarget" },
	function(unit)
		if unit.playerTarget then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauunitAggro", { "aggro", "combat" },
	function(unit)
		if unit.aggro then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaulevelText", { "level", "tier" },
	function(unit)
		if unit.level == "??" then
			return nil 
		elseif unit.tier == "raid" then
			return nil
		else 
			return unit.level
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaurangeColor", { "range" },
	function(unit)
		if unit.range > 35 then
			return { r=0.8, g=0, b=0, a=1.0 }
		else 
			return { r=0.9, g=0.9, b=0.9, a=1.0 }
		end
	end)

WT.Unit.CreateVirtualProperty("CkaurangeDisplay", { "range", "afk", "dead", "offline", "warfront" },
	function(unit)
		if unit.range == 0 then
			return nil
		else
			return unit.range
		end
	end)

WT.Unit.CreateVirtualProperty("CkaudifficultyColor", { "level", "tier" },
	function(unit)
		if not WT.Player.level then return nil end
		if type(WT.Player.level) == "string" then return nil end
		if not unit.level then return nil end
		if type(unit.level) == "string" then return nil end
		if unit.tier == "raid" then return nil end
		local xpLevel = unit.level - WT.Player.level
			if xpLevel > 5 then
				return { r=0.9, g=0, b=0, a=1.0 }
			elseif xpLevel > 2 and xpLevel <= 5 then
				return { r=0.9, g=0.5, b=0, a=1.0 }
			elseif xpLevel >= -2 and xpLevel <= 2 then
				return { r=0.9, g=0.9, b=0, a=1.0 }
			elseif xpLevel < -2 and xpLevel >= -5 then
				return { r=0, g=0.9, b=0, a=1.0 }
		else
			return { r=0.9, g=0.9, b=0.9, a=1.0 }
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaulevelBorder", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier == "raid" then
			return nil
		elseif unit.tier == "group" then
			return "CkaueliteIcon"
		elseif unit.guaranteedLoot and unit.tier then
			return "CkaueliteIcon"
		elseif unit.guaranteedLoot then
			return "CkaunormalIcon"
		else
			return "CkaunormalIcon"
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkauidBoss", { "level", "tier" },
	function(unit)
		if unit.tier == "raid" then
			return true
		else 
			return nil
		end
	end)
WT.Unit.CreateVirtualProperty("CkauidElite", { "level", "tier" },
	function(unit)
		if unit.tier == "group" then
			return true
		else 
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("CkaulevelUnknown", { "level", "tier" },
	function(unit)
		if unit.level == "??" then
			return true
		elseif unit.tier == "raid" then
			return true
		else
			return nil
		end
	end)
	
	
WT.Unit.CreateVirtualProperty("CkautargetBackdropIdElite", { "level", "tier", "relation" },
	function(unit)
		if unit.tier then
			return "CkautargetEliteBackdrop"
		else 
			return "CkautargetBackdrop"
		end
	end)
