local toc, data = ...
local AddonId = toc.identifier

-- Local config options ---------------------------------------------------------
local scale = 0.5
local manaOrbWidth = 256 * scale
local manaOrbHeight = 256 * scale
---------------------------------------------------------------------------------

-- Frame Configuration Options --------------------------------------------------
local ManaOrb = WT.UnitFrame:Template("CkauManaOrb")
ManaOrb.Configuration.Name = "Mana Orb / Орб Маны"
ManaOrb.Configuration.RaidSuitable = false
ManaOrb.Configuration.FrameType = "Frame"
ManaOrb.Configuration.Width = manaOrbWidth
ManaOrb.Configuration.Height = manaOrbHeight
---------------------------------------------------------------------------------


function ManaOrb:Construct(options)

	local template =
	{
		elements = 
		{
			{
				id="frameBackdrop", type="Image", parent="frame", layer=6,
				attach = 
				{ 
					{ point="TOPLEFT", element="frame", targetPoint="TOPLEFT" },
					{ point="BOTTOMRIGHT", element="frame", targetPoint="BOTTOMRIGHT" } 
				}, 				
				visibilityBinding="id", texAddon = AddonId, texFile = "img/orb_back2.tga"		
			}, 
			{
				id="blue", type="Bar", parent="frame", layer=10, alpha=1,
				attach = 
				{ 
					{ point="BOTTOMRIGHT", element="frame", targetPoint="BOTTOMRIGHT" } 
				}, visibilityBinding="id", binding="resourcePercent", growthDirection="up", texAddon=AddonId, texFile="img/Ckau_orb_blue.png", height=manaOrbHeight, width=manaOrbWidth,		
			}, 
			{
				id="gloss", type="Image", parent="frame", layer=14,
				attach = 
				{ 
					{ point="TOPLEFT", element="frame", targetPoint="TOPLEFT" },
					{ point="BOTTOMRIGHT", element="frame", targetPoint="BOTTOMRIGHT" } 
				}, visibilityBinding="id", texAddon = AddonId, texFile = "img/Ckau_orb_gloss.tga"		
			}, 
			{
				id="mana", type="Label", parent="frame", layer=18,
				attach = 
				{ 
					{ point="CENTER", element="frame", targetPoint="CENTER", offsetX=0, offsetY=-5 },
				}, visibilityBinding="id", text="{resource}",fontSize=24,font="RomicCyr", outline=true, 		
			}, 
			{
				id="manaPercent", type="Label", parent="frame", layer=14,
				attach = 
				{ 
					{ point="TOPCENTER", element="mana", targetPoint="BOTTOMCENTER", offsetX=3, offsetY=0 },
				}, visibilityBinding="id", text="{resourcePercent}%",fontSize=16,font="RomicCyr", outline=true, 		
			}, 
			
		}
	}
	
	for idx,element in ipairs(template.elements) do
		self:CreateElement(element) 
	end
	
	self:SetSecureMode("restricted")
	self:SetMouseoverUnit(self.UnitSpec)
	self:EventMacroSet(Event.UI.Input.Mouse.Left.Click, "target @" .. self.UnitSpec)
	self:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
		if self.UnitId then Command.Unit.Menu(self.UnitId) end
	end, "Event.UI.Input.Mouse.Right.Click")

	
end
